CT_ModVersion = "1.4";
CT_Mods = { };
CT_SlashCmds = { };
KP_Options = { };
RegisterForSave("KP_Options");
BINDING_NAME_CT_CPTOGGLE = "Toggle KP Options"; 
BINDING_HEADER_CT_CPBINDS = "KP_Mod Bindings";
function CT_Replace(text, search, replace)
	if ( search == replace) then return text; end
	local searchedtext = "";
	local textleft = text;
	while ( strfind ( textleft, search, 1) ) do
		searchedtext = searchedtext .. strsub ( textleft, 1, strfind( textleft, search, 1)-1 ) .. replace;
		textleft = strsub ( textleft, strfind( textleft, search, 1)+strlen(search) );
	end
	if ( strlen(textleft) > 0 ) then
		searchedtext = searchedtext .. textleft;
	end
	return searchedtext;
end

function CT_Print(msg, r, g, b, frame) 
	if ( not r ) then r=1.0; end;
	if ( not g ) then g=1.0; end;
	if ( not b ) then b=1.0; end;
	if ( frame ) then 
		frame:AddMessage(msg,r,g,b);
	else
		DEFAULT_CHAT_FRAME:AddMessage(msg, r, g, b);
	end
end

function CT_AddSlashCmd(command, func, descript, mod)
	local cmd = command;
	if ( strsub(cmd, 1, 1) ~= "/" ) then
		cmd = "/" .. cmd;
	end
	if ( SlashCmdList[cmd] ) then
		return "false";
	end
	SlashCmdList[cmd] = func;
	CT_SlashCmds[cmd] = cmd .. " - " .. descript;
	if ( mod ) then
		CT_SlashCmds[cmd] = CT_SlashCmds[cmd] .. " **" .. mod .. "**";
	end
	return "true";
end

function CT_RegisterMod(modName, modDescript, modIcon, modTooltip, modStatus, modValue, modFunc, modFrameWatch)
	local temp = { };
	if ( modName and strlen(modName) > 0 ) then temp["modName"] = modName; else temp["modName"] = ""; end
	if ( modDescript and strlen(modDescript) > 0 ) then temp["modDescript"] = modDescript; else temp["modDescript"] = ""; end
	if ( modTooltip and strlen(modTooltip) > 0 ) then temp["modTooltip"] = modTooltip; else temp["modTooltip"] = ""; end
	if ( modIcon and strlen(modIcon) > 0 ) then temp["modIcon"] = modIcon; else temp["modIcon"] = "Interface\\Icons\\INV_Misc_QuestionMark"; end
	if ( modStatus )  then temp["modStatus"] = modStatus; else temp["modStatus"] = "off"; end
	if ( modValue ) then temp["modValue"] = modValue; end
	if ( modFunc ) then temp["modFunc"] = modFunc; end
	if ( modFrameWatch ) then temp["modWatch"] = modFrameWatch; end

	tinsert(CT_Mods, temp);
end

function CT_GetModStatus(modName)
	for key, val in CT_Mods do
		if ( val["modName"] == modName ) then
			return val["modStatus"];
		end
	end
end

function CT_SetModStatus(modName, status)
	for key, val in CT_Mods do
		if ( val["modName"] == modName ) then
			CT_SaveInfoName(modName);
			val["modStatus"] = status; break;
		end
	end
end

function CT_SaveInfoName(modName)
	for key, val in CT_Mods do
		if ( val["modName"] == modName ) then
			KP_Options[key] = val;
		end
	end
end

function CT_IsQuestRecorded(title, money)
	local datatitle, datamoney;
	if ( CT_Data_Quests[title.."|"..money] ) then
		return "true";
	else
		return "false";
	end
end

function CT_RecordQuest(title, money)
	RegisterCVar("WPQuest1", title.."|"..money);
end

function CT_Master_OnEvent(event)
	if ( event == "VARIABLES_LOADED" ) then
		if ( not KP_Options["runonce"] ) then
			for key, val in KP_Options do
				KP_Options[key] = nil;
			end
			KP_Options["runonce"] = 1;
			CT_Print("<KeRn-Pack> Nouvel version, reglage remis par defaut. Sorry!", 1.0, 0.0, 0.0);
			return;
		end
		ResetBindings();
		for key, val in KP_Options do
			if ( key ~= "runonce" ) then
-- dbrong
				if (not CT_Mods[key]) then
					CT_Mods[key] = {};
				end
-- end dbrong
				local modFunc = CT_Mods[key]["modFunc"];
				CT_Mods[key] = val;
				CT_Mods[key]["modFunc"] = modFunc;
			end
		end
		CT_Sidebar_Update();
		CT_Hotbar_Update();
--		CT_AutoJoin_Update();
	end
end	