function StartFrame_OnLoad()
	func = function()
		if ( StartFrame:IsShown() ) then
			StartFrame:Hide();
		else
			StartFrame:Show();
		end
	end

	CT_AddSlashCmd("/CTStart", func, "Toggles the KPMod options frame.");
end

function StartFrame_OnShow()
	UpdateMicroButtons();
	StartFrame_Update();
	StartButton_UpdateSelection();
	StartButton_UpdateButton();
end

function StartFrame_Update()
	StartTitleText:SetText("KeRn - Pack");
	PlaySound("igSpellBookOpen");
end


function StartFrame_OnHide()
	PlaySound("igSpellBookClose");
end	UpdateMicroButtons();


function StartButton_OnLoad()
	local buttonid = this:GetID();
	for id, value in CT_Mods do
		if ( id == buttonid ) then
			if ( value["modValue"] ) then 
				getglobal(this:GetName() .. "Count"):SetText(value["modValue"]); 
				break;
			end
		end
	end

	this:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	StartButton_UpdateButton();
end

function StartButton_OnEnter()
	local buttonid = this:GetID();
	for id, value in CT_Mods do
		if ( id == buttonid ) then
			GameTooltip:SetOwner(this, "ANCHOR_RIGHT");
			local tooltip = value["modTooltip"];
			if ( value["modStatus"] == "disabled" ) then tooltip = "Coming Soon..."; end
			if ( GameTooltip:SetText(tooltip) ) then
				this.updateTooltip = TOOLTIP_UPDATE_TIME;
			else
				this.updateTooltip = nil;
			end
		end
	end
end

function StartButton_OnUpdate(elapsed)
	if ( CT_Mods[this:GetID()] and CT_Mods[this:GetID()]["modWatch"] ) then
		if ( getglobal(CT_Mods[this:GetID()]["modWatch"]) and getglobal(CT_Mods[this:GetID()]["modWatch"]):IsVisible() ) then
			this:SetChecked(1);
			CT_Mods[this:GetID()]["modStatus"] = "on";
		else
			this:SetChecked(0);
			CT_Mods[this:GetID()]["modStatus"] = "off";
		end
	end
	if ( not this.updateTooltip ) then
		return;
	end

	this.updateTooltip = this.updateTooltip - elapsed;
	if ( this.updateTooltip > 0 ) then
		return;
	end

	if ( GameTooltip:IsOwned(this) ) then
		StartButton_OnEnter();
	else
		this.updateTooltip = nil;
	end
	
end

function StartButton_OnClick()
	--for i, value in CT_Mods do
		--if ( i == this:GetID() ) then
		local i= this:GetID();
		local value = CT_Mods[i];
		if ( not value ) then return; end
			if ( value["modStatus"] == "switch" ) then
				if ( CT_Mods[i]["modFunc"] ) then
					CT_Mods[i]["modFunc"](i, getglobal("StartButton" .. this:GetID() .. "Count"));
					CT_SaveInfoName(value["modName"]);
				end
				this:SetChecked("false");
				return;
			end

			if ( value["modStatus"] == "off" ) then
				this:SetChecked("true");
				CT_SetModStatus(value["modName"], "on");
			elseif ( value["modStatus"] == "switch" ) then
				if ( CT_Mods[i]["modFunc"] ) then
					CT_Mods[i]["modFunc"](getglobal(this:GetName() .. "Count"));
				end
			else
				this:SetChecked("false");
				CT_SetModStatus(value["modName"], "off");
			end
			if ( CT_Mods[i]["modFunc"] ) then
				CT_Mods[i]["modFunc"]();
			end

		--end
	--end
end

function StartButton_UpdateSelection()
	for i, value in CT_Mods do
		local button = getglobal("StartButton"..i);
		if ( button and value["modStatus"] == "on" ) then
			button:SetChecked("true");
		elseif ( button and ( value["modStatus"] ~= "on" or value["modStatus"] == "switch" ) ) then
			button:SetChecked("false");
		end
	end
end

function StartButton_UpdateButton()
	for i = 1, 6, 1 do
		local icon = getglobal("StartButton"..i .. "NormalTexture");
		local iconTexture = getglobal("StartButton"..i.."IconTexture");
		local iconName = getglobal("StartButton"..i.."Name");
		local iconDescription = getglobal("StartButton"..i.."SubName");
		local highlightTexture = getglobal("StartButton"..i.."Highlight");
		local normalTexture = getglobal("StartButton"..i.."NormalTexture");
		local iconCount = getglobal("StartButton"..i.."Count");
		
		local modString = getglobal("StartButton"..i.."Name");
		local descriptString = getglobal("StartButton"..i.."SubName");
		local modName, modDescript, modIcon, modValue;

		if ( icon ) then icon:Hide(); end
		if ( iconTexture ) then iconTexture:Hide(); end
		if ( iconName ) then iconName:Hide(); end
		if ( iconDescription ) then iconDescription:Hide(); end

		for key, val in CT_Mods do
			if ( key == i ) then
				if ( icon ) then icon:Show(); end
				if ( iconTexture ) then iconTexture:Show(); iconTexture:SetVertexColor(1.0, 1.0, 1.0); end
				if ( highlightTexture ) then highlightTexture:SetTexture("Interface\\Buttons\\ButtonHilight-Square"); end
				if ( modString ) then modString:SetTextColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b); end
				modStatus = val["modStatus"];
				modName = val["modName"];
				modDescript = val["modDescript"];
				modIcon = val["modIcon"];
				modValue = val["modValue"];
				if ( iconTexture ) then iconTexture:SetTexture(modIcon); end
				if ( modString ) then modString:SetText(modName); end
				if ( descriptString ) then descriptString:SetText(modDescript); end
				if ( iconCount ) then iconCount:SetText(modValue); end
				if ( modString ) then modString:Show(); end
				if ( descriptString ) then descriptString:Show(); end
				if ( modStatus == "disabled" ) then
					if ( iconTexture ) then iconTexture:SetVertexColor(0.5, 0.5, 0.5); end
				end
				break;
			end
		end
	end
		StartButton_UpdateSelection();
end

