
LockBar_Locked = false;

LockBar_Saved_PickupAction = nil;

-- hooked function
function LockBar_PickupAction(id)
	if ( LockBar_ShouldAllowPickupAction() ) then
		LockBar_Saved_PickupAction(id);
	end
end

function LockBar_ShouldAllowPickupAction()
	if ( ( LockBar_Locked ~= 1 ) or ( IsShiftKeyDown() ) ) then
		return true;
	else
		return false;
	end
end

function LockBar_Setup_Hooks(toggle)
	if ( toggle ) then
		if ( ( PickupAction ~= LockBar_PickupAction ) and (LockBar_Saved_PickupAction == nil) ) then
			LockBar_Saved_PickupAction = PickupAction;
			PickupAction = LockBar_PickupAction;
		end
	else
		if ( PickupAction == LockBar_PickupAction) then
			PickupAction = LockBar_Saved_PickupAction;
			LockBar_Saved_PickupAction = nil;
		end
	end
end

function LockBar_OnClick()
	LockBar_SetState(this:GetChecked());
end

function LockBar_OnEvent(event)
	if ( event == "VARIABLES_LOADED" ) then
		LockBar_SetState(LockBar_Locked);
	end
end

function LockBar_SetState(toggle)
	if ( ( toggle ) or ( toggle == 1 ) ) then
		LockBar_Locked = 1;
		ActionLockButton:SetChecked(1);
	else
		LockBar_Locked = 0;
		ActionLockButton:SetChecked(0);
	end
end

function LockBar_OnLoad()
	LockBar_Setup_Hooks(true);
	LockBar_SetState(LockBar_Locked);
	RegisterForSave("LockBar_Locked");
	this:RegisterEvent("VARIABLES_LOADED");
end

function LockBar_OnEnter()
	GameTooltip:SetOwner(this, "ANCHOR_RIGHT");
	GameTooltip:SetText(TEXT(LOCKBAR_BUTTON_TOOLTIP), 1.0, 1.0, 1.0);
end

function LockBar_OnLeave()
	if ( GameTooltip:IsOwned(this) ) then
		GameTooltip:Hide();
	end 
end

